module Optipipe
  module Generators
    class InstallGenerator < Rails::Generators::Base
      source_root File.expand_path("../../templates", __FILE__)

      desc "Creates a Optipipe initializer to your application."

      def copy_initializer
        # config file
        template "optipipe.rb", "config/initializers/optipipe.rb"

        # javascript's templates
        empty_directory 'app/assets/javascripts/optipipe'
        empty_directory 'app/assets/javascripts/optipipe/files'
        empty_directory 'app/assets/javascripts/optipipe/mappers'
        empty_directory 'app/assets/javascripts/optipipe/precompiles'
        template        'files/example.js',                               'app/assets/javascripts/optipipe/files/example.js'
        template        'files/example_after_onload.js',                  'app/assets/javascripts/optipipe/files/example_after_onload.js'
        template        'precompiles/example_precompile.js',              'app/assets/javascripts/optipipe/precompiles/example_precompile.js'
        template        'precompiles/example_precompile_after_onload.js', 'app/assets/javascripts/optipipe/precompiles/example_precompile_after_onload.js'
        template        'mappers/example_mapper_for_javascripts.yml',     'app/assets/javascripts/optipipe/mappers/example_mapper.yml'

        # stylesheet's templates
        empty_directory 'app/assets/stylesheets/optipipe'
        empty_directory 'app/assets/stylesheets/optipipe/files'
        empty_directory 'app/assets/stylesheets/optipipe/mappers'
        empty_directory 'app/assets/stylesheets/optipipe/precompiles'
        template        'files/example.css',                          'app/assets/stylesheets/optipipe/files/example.css'
        template        'precompiles/example_precompile.css',         'app/assets/stylesheets/optipipe/precompiles/example_precompile.css'
        template        'mappers/example_mapper_for_stylesheets.yml', 'app/assets/stylesheets/optipipe/mappers/example_mapper.yml'
      end
    end
  end
end
