module Optipipe
  if defined?(Rails::Railtie)
    class Railtie < Rails::Railtie
      # Parse the mappers before any of the initializers
      initializer :load_optipipe_mappers, :before => :load_environment_config do
        Optipipe::Mapper.load_yamls!
      end

      # Rails Dev environment should reload the mapper settings on every request
      if Rails.env.development?
        initializer :optipipe_reload_on_development do
          if Rails::VERSION::MAJOR == 3
            ActionController::Base.class_eval do
              prepend_before_filter { ::Optipipe::Mapper.load_yamls! }
            end
          else
            ActionController::Base.class_eval do
              prepend_before_action { ::Optipipe::Mapper.load_yamls! }
            end
          end
        end
      end
    end
  end
end
